class MAndM::Preferences
  attr_reader :preferences_path, :hash

  def initialize name
    @preferences_path = File.join File.expand_path('~'), name
    if File.exists? preferences_path
      @hash = YAML.load_file preferences_path
    else
      @hash = {}
    end
  end

  def ask key, prompt
    unless hash[key]
      print "#{prompt} ? "
      self[key] = $stdin.gets.chomp
    end
    self[key]
  end

  def [] key
    hash[key]
  end

  def []= key, value
    hash[key] = value
    persist
  end

  def persist
    File.open(preferences_path, 'w') {|f| f.puts hash.to_yaml}
  end
end