require 'httparty'

MAndM::Server = Struct.new :base_url, :preferences

class MAndM::Server
  def messages
    HTTParty.get message_url
  end

  def say to_uuid, message_id
    HTTParty.post base_url,
      body: message_body(to_uuid, message_id),
      headers: headers
  end

private

  def message_body to_uuid, message_id
    {uuid: token, to_uuid: to_uuid, message_id: message_id}
  end

  def headers
    {'ContentType' => 'application/json'}
  end

  def last_message_id
    preferences[:last_message_id]
  end

  def token
    preferences.ask :token, 'What is the authentication token'
  end

  def authenticated_base_url
    "#{base_url}?uuid=#{token}"
  end

  def message_url
    last_message_id ? "#{authenticated_base_url}&id=#{last_message_id}" : authenticated_base_url
  end
end
